/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.vo;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import jp.mosp.common.CommonConst;
import jp.mosp.common.MosPVo;
import jp.mosp.system.dto.MCodeDto;

public class HolidayMasterListVo extends MosPVo {

	private static final long serialVersionUID = -5821780591448938644L;

	// URL、CSS
	private static final String RETURN_URL	= "/jsp/system/holidayMasterList.jsp";
	private static final String EXTRA_JS		= "/pub/system/js/holidayMasterList.js";
	private static final String EXTRA_CSS		= "/pub/system/css/holidayMasterList.css";

	// 画面サブタイトル
	public final String SUB_TITLE = CommonConst.TTL_HOLIDAY_MASTER;

	//定数
	public static final int SEARCH_OFF = 0;
	public static final int SEARCH_ON  = 1;

	// パラメータ名
	public static final String PRM_TXT_H_DATE		= "txtHDate";
	public static final String PRM_TXT_H_NAME		= "txtHName";

	// フィールド
	private String[]	aryHDate;
	private String[]	aryHName;
	private String		txtHDate;
	private String		txtHName;

	// フィールド名及び制限
	public static final String NAM_H_DATE		= CommonConst.NAM_DATE;
	public static final String NAM_H_NAME		= CommonConst.NAM_COMMON_MEISYO;

	public static final int	LEN_H_DATE		= 50;
	public static final int	LEN_H_NAME		= 50;

	// ソートキー	
	public final String KEY_H_CODE		= "keyHDate";
	public final String KEY_H_NAME		= "keyHName";

	// モード(0：検索なし、1：検索あり)
	private int searchmode;

	/**
	 * コンストラクタ
	 */
	public HolidayMasterListVo() {
		super();
		setRetUrl(RETURN_URL);
		addExtraJs(EXTRA_JS);
		setExtraCss(EXTRA_CSS);
		txtHDate		= "";
		txtHName		= "";
		aryHDate		= new String[0];
		aryHName		= new String[0];
		setFormerKey(KEY_H_CODE);
	}

	/**
	 * パラメータ設定
	 * @param request リクエスト
	 */
	public void setParams(HttpServletRequest request) {
		txtHDate	= request.getParameter(PRM_TXT_H_DATE);
		txtHName	= request.getParameter(PRM_TXT_H_NAME);
	}

	/**
	 * フィールド設定
	 * @param listCode	祝祭日コードリスト
	 */
	public void setFields(List listCode) {
		// リストの設定
		list = listCode;
		// データ総数の取得
		count = listCode.size();
		// 配列の初期化
		aryHDate	= new String[count];
		aryHName	= new String[count];
		// データの設定
		int i = 0;
		Iterator it = listCode.iterator();
		while (it.hasNext()) {
			MCodeDto dto = (MCodeDto)it.next();
			aryHDate[i]		= escapeHTML(dto.getTCode());
			aryHName[i]		= escapeHTML(dto.getTName());
			i++;
		}
	}

	/**
	 * JavaScript設定
	 * @param cls 情報取得クラス
	 * @throws IllegalAccessException
	 */
	@Override
	public String getDirectJs(Class cls) throws IllegalAccessException {
		StringBuffer sb = new StringBuffer();
		sb.append(super.getDirectJs(cls));
		return sb.toString();
	}

	// アクセサメソッド
	public String[] getEscAryHDate		() { return aryHDate.clone()	; }
	public String[] getEscAryHName		() { return aryHName.clone()	; }

	public String getTxtHDate		() { return txtHDate	; }
	public String getTxtHName		() { return txtHName	; }

	public String getEscTxtHDate	() { return escapeHTML(txtHDate)	; }
	public String getEscTxtHName	() { return escapeHTML(txtHName)	; }

	public void setSearchmode(int searchmode) { this.searchmode = searchmode; }
	public int getSearchmode() { return searchmode; }

	public void setTxtHDate(String txtHDate) { this.txtHDate = txtHDate; }

}
